Ruby - Bug #13662

prohibit machine stackoverflow while GC
06/15/2017 07:14 AM - ko1 (Koichi Sasada)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description

We have encounter GC marking miss after [Feature #13637] r59047 at test-rubyspec.

I, [2017-06-15T04:31:33.467582 #2820] INFO -- :

/home/k

o1/ruby/src/trunk/spec/rubyspec/core/encoding/converter/convpath_spec.rb:7: [BUG] rb_gc_mark(): 0x0000000001cbbf78 is

T_NONE

http:/ci.rvm.jp/results/trunk@P895/1497485282
http://ci.rvm.jp/results/trunk@P895/1497479452
http://ci.rvm.jp/results/trunk@P895/1497468696
... and more (not frequent).

My current assumption is machine stack overflow while GC and finishing marking phase incomplete.

To prevent such situation (incomplete GC), I'll prohibit machine stack overflow while running GC.

Index: vm_insnhelper.c

——— vm_insnhelper.c (revision 59088)
+++ vm_insnhelper.c (working copy)
@@ -56,8 +56,11 @@
void
rb_threadptr_stack_overflow (rb_thread_t *th)
{

+ if (rb_during_gc()) {
+ rb_fatal ("machine stack overflow while GC is running.");
+ }

#ifdef USE_SIGALTSTACK
. threadptr_stack_overflow(th, !rb_threadptr_during_gc(th));
+ threadptr_stack_overflow(th, TRUE);
#else
threadptr_stack_overflow(th, FALSE);
#endif

Associated revisions

Revision e64e3c4c21361565fa03c49292e6918e0eb7693 - 06/15/2017 07:16 AM - ko1 (Koichi Sasada)
Prohibit SystemStackError while GC.

e vm_insnhelper.c (rb_threadptr_stack_overflow): fatal on GC [Bug #13662]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59089 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision e64e3c4c - 06/15/2017 07:16 AM - ko1 (Koichi Sasada)
Prohibit SystemStackError while GC.

e vm_insnhelper.c (rb_threadptr_stack_overflow): fatal on GC [Bug #13662]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59089 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
https://bugs.ruby-lang.org/issues/13637
http://ci.rvm.jp/results/trunk@P895/1497485282
http://ci.rvm.jp/results/trunk@P895/1497479452
http://ci.rvm.jp/results/trunk@P895/1497468696

History

#1 - 06/15/2017 07:16 AM - ko1 (Koichi Sasada)
- Status changed from Open to Closed

Applied in changeset trunk|r59089.

Prohibit SystemStackError while GC.

e vm_insnhelper.c (rb_threadptr_stack_overflow): fatal on GC [Bug #13662]
